/***************************************************************************
 *   Copyright (C) 2005 by Oliver Saal                                     *
 *   http://www.oliver-saal.de/                                            *
 *   osaal@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef CONFIG_H
#define CONFIG_H

#include <qstring.h>
#include <qstringlist.h>

class QComboBox;

class CConfig
{
public:
	CConfig ();
	~CConfig ();

	void Load ();
	void Save ();

	bool UpdateCheckNow ();
	bool FindDatabase ();

//	inline QString GetLocale () const		{ return m_strLocale; }

	void AppendStart (const QString str);
	void AppendDestination (const QString str);

	void FillStartCombo (QComboBox *pBox);
	void FillDestinationCombo (QComboBox *pBox);


public:
	QString m_strQMPath;
	QString m_strDBFile;
	int m_iDBVersion;
	QString m_strLocale;
	
	bool m_bShowAll;
	bool m_bAllowCrossesAsStart;

	int m_iAxes;
	int m_iPollutant;

	int m_iUpdateInterval;
	unsigned m_uLastUpdate;

	QStringList m_strlStart;
	QStringList m_strlDestination;
	unsigned m_uMaxLastNodes;
};

#endif
