/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/


void CDlgOptions::init()
{
	m_pAppTranslator = NULL;
	m_pQtTranslator = NULL;
/*	m_iHTTPStep = 0;
	m_pProgress = new QProgressDialog (this);
	connect (&m_http, SIGNAL(dataReadProgress(int, int)), m_pProgress, SLOT(setProgress (int, int)));
	connect (m_pProgress, SIGNAL(canceled()), &m_http, SLOT (abort()));
	connect (&m_http, SIGNAL(done(bool)), this, SLOT(onHTTPDone(bool)));
*/
	initComboBoxes();
}


void CDlgOptions::onLanguageChanged( int index )
{
	if (m_pAppTranslator != NULL) m_pAppTranslator->load("mautrechner_" + m_strlLocales[index], m_pConfig->m_strQMPath);
	if (m_pQtTranslator != NULL) m_pQtTranslator->load("qt_" + m_strlLocales[index], m_pConfig->m_strQMPath);
	initComboBoxes();
}

void CDlgOptions::onOK()
{
int index = m_cbLanguage->currentItem();

	m_pConfig->m_strLocale = m_strlLocales[index];
	m_pConfig->m_strDBFile = m_leDBFile->text();
	m_pConfig->m_iUpdateInterval = m_cbUpdate->currentItem();
	m_pConfig->m_bAllowCrossesAsStart = m_checkTriangle->isChecked();

	if (m_pAppTranslator != NULL) m_pAppTranslator->load("mautrechner_" + m_strlLocales[index], m_pConfig->m_strQMPath);
	if (m_pQtTranslator != NULL) m_pQtTranslator->load("qt_" + m_strlLocales[index], m_pConfig->m_strQMPath);

	accept();
}


void CDlgOptions::onCancel()
{

	if (m_pAppTranslator != NULL) m_pAppTranslator->load("mautrechner_" + m_pConfig->m_strLocale, m_pConfig->m_strQMPath);
	if (m_pQtTranslator != NULL) m_pQtTranslator->load("qt_" + m_pConfig->m_strLocale, m_pConfig->m_strQMPath);
	
	reject();
}


void CDlgOptions::onSelect()
{
QString strFile = QFileDialog::getOpenFileName (m_leDBFile->text(), tr("CSV-Files (*.csv);;All files (*.*)"), this);
	if (strFile.isEmpty()) return;
	m_leDBFile->setText (QDir::convertSeparators(strFile));
}


void CDlgOptions::onUpdate()
{
QString strPath = qApp->applicationDirPath()+"/../data/";
QDir dir (strPath);
	if (!dir.exists() && !dir.mkdir (strPath))
	{
		QMessageBox::critical (this, tr("Error"), tr("Could not create the directory\n%1").arg(strPath));
		return;
	}
	connect (m_pUpdater, SIGNAL (UpdateInfoReceived()), this, SLOT(onUpdateInfoReceived()));
	m_pUpdater->Abort();
	m_pUpdater->GetUpdateInfo(false);
/*	m_iHTTPStep=1;
	m_pProgress->setLabelText (tr("Downloading configuration..."));
	m_http.setHost ("www.oliver-saal.de");
	m_http.get ("/software/mautrechner/data/update.txt");
*/
}



int CDlgOptions::go( CConfig *pConfig, CUpdater *pUpdater, QTranslator *pAppTranslator, QTranslator *pQtTranslator )
{
	m_pConfig = pConfig;
	m_pUpdater = pUpdater;
	m_pAppTranslator = pAppTranslator;
	m_pQtTranslator = pQtTranslator;
	connect (m_pUpdater, SIGNAL (DatabaseReceived(QString)), this, SLOT(onDatabaseReceived(QString)));

	QDir dir (m_pConfig->m_strQMPath);
	QStringList strlFiles = dir.entryList ("mautrechner_*.qm");

	for (int i=0; i<strlFiles.count(); i++)
	{
		QString strLocale = strlFiles[i];
		strLocale = strLocale.mid (strLocale.find('_') + 1);
		strLocale.truncate(strLocale.find ('.'));

		QTranslator translator;
		translator.load (strlFiles[i], m_pConfig->m_strQMPath);

		QTranslatorMessage message = translator.findMessage ("CDlgTollCalculator", "English");
		QString strLanguage = message.translation ();

		m_strlLocales.append (strLocale);
		QPixmap pix;

		if (pix.load (m_pConfig->m_strQMPath+strLocale+".png"))
			m_cbLanguage->insertItem (pix, strLanguage);

		if (strLocale == m_pConfig->m_strLocale) 
			m_cbLanguage->setCurrentItem (i);
	}

	m_leDBFile->setText (QDir::convertSeparators(m_pConfig->m_strDBFile));
	m_cbUpdate->setCurrentItem (m_pConfig->m_iUpdateInterval);
	m_checkTriangle->setChecked (m_pConfig->m_bAllowCrossesAsStart);

	return (exec());
}

/*
void CDlgOptions::onHTTPDone( bool bError )
{
QHttpRequestHeader request;
QString strLine;
QString strHost;
QString strPath;
QString strDataFile;
int iVersion=0;

	m_pProgress->close();
	if (bError)
	{
		QMessageBox::critical (this, tr("Error"), tr("Could not download file.\n%1").arg(m_http.errorString()));
		return;
	}
	if (!m_http.bytesAvailable())	
	{
		QMessageBox::critical (this, tr("Error"), tr("Could not download file.\n%1").arg(m_http.currentRequest().path()));
		return;
	}
	if (m_iHTTPStep == 1)
	{
		QTextStream stream (m_http.readAll(), IO_ReadOnly);
		while (!stream.atEnd ())
		{
			strLine = stream.readLine ().stripWhiteSpace();
			if (strLine.isEmpty()) continue;
			if (strLine[0] == '#') continue;
			if (strLine.find ('=') < 0) continue;
			if (strLine.find ("host") == 0)
				strHost = strLine.mid (strLine.find('=')+1).stripWhiteSpace();
			if (strLine.find ("path") == 0)
				strPath = strLine.mid (strLine.find('=')+1).stripWhiteSpace();
			if (strLine.find ("version") == 0)
				iVersion = strLine.mid (strLine.find('=')+1).stripWhiteSpace().toInt();
		}
		if (strPath.isEmpty() || strHost.isEmpty() || iVersion == 0)
		{
			QMessageBox::critical (this, tr("Error"), tr("Could not read update configuration."));
			return;
		}
		if (m_pConfig->m_iDBVersion >= iVersion)
		{
			QMessageBox::information (this, tr("Information"), tr("You have allready the newest database.\nAn update is not necessary."));
			return;
		}

		m_http.setHost (strHost);
		request = QHttpRequestHeader ("GET", strPath);
		//m_http.request (request);
		m_pProgress->setLabelText (tr("Downloading data from %1...").arg(strHost));
		m_http.get (strPath);
		m_iHTTPStep = 2;
	}
	else
	{
		m_pProgress->close();
	}
}
*/


void CDlgOptions::initComboBoxes()
{
int i = m_cbUpdate->currentItem();
    m_cbUpdate->clear();
    m_cbUpdate->insertItem( tr( "Never" ) );
    m_cbUpdate->insertItem( tr( "Every day" ) );
    m_cbUpdate->insertItem( tr( "Once a week" ) );
    m_cbUpdate->insertItem( tr( "Once a month" ) );
	m_cbUpdate->setCurrentItem (i);
}


void CDlgOptions::onUpdateInfoReceived( void )
{
	if (m_pUpdater->m_iSoftwareVersion > MAUTRECHNER_VERSION)
	{
		QMessageBox::information (this, tr("Update notification"),
			tr ("There exists a newer version of this software.\nPlease download it from http://www.oliver-saal.de/software/mautrechner/"));
	}
	if (m_pConfig->m_iDBVersion >= m_pUpdater->m_iDBVersion)
	{
		QMessageBox::information (this, tr("Information"), tr("You have allready the newest database.\nAn update is not necessary."));
		return;
	}
	else m_pUpdater->GetDatabase ();
}


void CDlgOptions::onDatabaseReceived( QString strFile )
{
	m_leDBFile->setText (QDir::convertSeparators(strFile));
}
