/***************************************************************************
 *   Copyright (C) 2005 by Oliver Saal                                     *
 *   http://www.oliver-saal.de/                                            *
 *   osaal@gmx.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/ 

#ifndef UPDATER_H
#define UPDATER_H

#include <qobject.h>
#include <qstring.h>
#include <qhttp.h>
#include <qprogressdialog.h>

class CUpdater : public QObject
{
Q_OBJECT
public:
	CUpdater (QWidget *pParent, const char *name=0);
	~CUpdater ();

	void GetUpdateInfo (const bool bBackground);
	void GetDatabase (void);
	void Abort (void);

protected slots:
//	void onHTTPDone (bool bError);
	void onHttpRequestFinished (int id, bool bError);
	void onHttpResponseHeaderReceived (const QHttpResponseHeader &resp);

	bool ExtractUpdateInfo (QByteArray array);

protected:
	QWidget *m_pParent;
	QProgressDialog *m_pProgress;

	QHttp m_http;
	QHttpResponseHeader m_response;

	int m_iRequInfoID;
	int m_iRequDBID;

	void InitProgressDialog (QString strLabel); 
	void CloseProgressDialog ();

signals:
	void UpdateInfoReceived (void);
	void DatabaseReceived (QString strFile);

public:
	unsigned m_uLastUpdateCheck;

	// Database update
	QString m_strDBHost;
	QString m_strDBPath;
	int m_iDBVersion;

	// Software update
	QString m_strSoftwarePath;
	int m_iSoftwareVersion;
};

#endif